<?php namespace Lib;
/**
 * @author xiaozi <245565986@qq.com>
 */

class Base62 {
	const BASE = '0123456789abcdefghijklmnopqrstuvwxyzABCDEFGHIJKLMNOPQRSTUVWXYZ';
	const HEX = 62;
	/**
	 * base62 编码 
	 * @param  int $num 只支持数字类型的
	 * @return string      返回值
	 */
	public static function encode($num) {
		$r = $num % self::HEX;
		$base = self::BASE;
		$res = $base{$r};
		$q = floor($num / self::HEX);
		while ($q) {
			$r = $q % self::HEX;
			$q = floor($q / self::HEX);
			$res = $base{$r} . $res;
		}
		return $res;
	}

	/**
	 * base62 解码
	 * @param  string $num 不解释
	 * @return int      返回值
	 */
	public static function decode($num) {
		$limit = strlen($num);
		$res = strpos(self::BASE, $num{0});
		for ($i = 1; $i < $limit; $i++) {
			$res = self::HEX * $res + strpos(self::BASE, $num{$i});
		}
		return $res;
	}
}
